淘宝Tengine安装指南
前期准备:
服务器IP:192.168.200.129
配置yum仓库:
[root@crushlinux ~]# mount /dev/cdrom /mnt[root@crushlinux ~]# cat /etc/yum.repos.d/yum.repo[server]name=serverbaseurl=file:///mnt/Serverenable=1gpgcheck=0
下载软件:
[root@crushlinux ~]# cd /usr/src/[root@crushlinux src]# wget ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/pcre-8.33.tar.gz[root@crushlinux src]# wget http://labs.frickle.com/files/ngx_cache_purge-2.1.tar.gz[root@crushlinux src]# wget http://tengine.taobao.org/download/tengine-1.5.1.tar.gz
一、安装pcre:
[root@crushlinux src]# tar zxvf pcre-8.33.tar.gz[root@crushlinux src]# cd pcre-8.33[root@crushlinux pcre-8.33]# ./configure --prefix=/usr/local/pcre[root@crushlinux pcre-8.33]# make && make install
二、解压proxy_cache插件
[root@crushlinux pcre-8.33]# cd ../[root@crushlinux src]# tar zxvf ngx_cache_purge-2.1.tar.gz
三、安装Tengine
[root@crushlinux src]# yum install openssl openssl-devel -y[root@crushlinux src]# tar zxvf tengine-1.5.1.tar.gz[root@crushlinux src]# cd tengine-1.5.1[root@crushlinux tengine-1.5.1]# ./configure --add-module=/usr/src/ngx_cache_purge-2.1 --prefix=/usr/local/nginx --with-http_stub_status_module --with-pcre=/usr/src/pcre-8.33[root@crushlinux tengine-1.5.1]# make && make install
注意:
--prefix=/usr/local/nginx指定安装路径
--with-pcre=/usr/src/pcre-8.33 指定pcre的解压路径
--add-module=/usr/src/ngx_cache_purge-2.1 指定加载缓存插件模块
报错解决方案:
一 ./configure: error: the HTTP SSL module requires OpenSSL library
解决:yum -y install openssl-devel
二 ./configure: error: the HTTP rewrite module requires the PCRE library.
解决:yum -y install pcre-devel
四、设置Tengine启动启动脚本
在/etc/init.d/下创建一个文件名称随意(建议起名为:nginx)
[root@crushlinux tengine-1.5.1]# cat /etc/init.d/nginx
#!/bin/bash# Tengine Startup script# processname: nginx# chkconfig: - 85 15# description: nginx is a World Wide Web server. It is used to serve# pidfile: /var/run/nginx.pid# config: /usr/local/nginx/conf/nginx.confnginxd=/usr/local/nginx/sbin/nginxnginx_config=/usr/local/nginx/conf/nginx.confnginx_pid=/usr/local/nginx/logs/nginx.pidRETVAL=0prog="nginx"# Source function library.. /etc/rc.d/init.d/functions# Source networking configuration.. /etc/sysconfig/network# Check that networking is up.[ ${NETWORKING} = "no" ] && exit 0[ -x $nginxd ] || exit 0# Start nginx daemons functions.start() {if [ -e $nginx_pid ];thenecho "tengine already running...."exit 1fiecho -n $"Starting $prog: "daemon $nginxd -c ${nginx_config}RETVAL=$?echo[ $RETVAL = 0 ] && touch /var/lock/subsys/nginxreturn $RETVAL}# Stop nginx daemons functions.stop() {echo -n $"Stopping $prog: "killproc $nginxdRETVAL=$?echo[ $RETVAL = 0 ] && rm -f /var/lock/subsys/nginx /usr/local/nginx/logs/nginx.pid}reload() {echo -n $"Reloading $prog: "#kill -HUP `cat ${nginx_pid}`killproc $nginxd -HUPRETVAL=$?echo}# See how we were called.case "$1" instart)start;;stop)stop;;reload)reload;;restart)stopstart;;status)status $progRETVAL=$?;;*)echo $"Usage: $prog {start|stop|restart|reload|status|help}"exit 1esacexit $RETVAL
[root@crushlinux tengine-1.5.1]# chmod +x /etc/init.d/nginx 为脚本添加执行权限
[root@crushlinux tengine-1.5.1]# chkconfig nginx on设置为开机自启
[root@crushlinux tengine-1.5.1]# chkconfig --list nginx查看
nginx 0:关闭 1:关闭 2:启用 3:启用 4:启用 5:启用 6:关闭
[root@crushlinux tengine-1.5.1]# service nginx start启动Tengine
启动 nginx: [确定]
五、配置Tengine
1)配置前先备份nginx配置文件
[root@crushlinux tengine-1.5.1]# mv /usr/local/nginx/conf/nginx.conf /usr/local/nginx/conf/nginx.conf.bak
2)创建nginx程序用户www
[root@crushlinux tengine-1.5.1]# groupadd www
[root@crushlinux tengine-1.5.1]# useradd -g www -s /sbin/nologin www
3)编辑主配置文件:
[root@crushlinux tengine-1.5.1]# cd /usr/local/nginx/conf/
[root@crushlinux conf]# vi nginx.conf添加时请删除汉字注释信息
user www www; #定义运行用户及运行组worker_processes 4; #定义工作进程数,通常为CPU的核心数或者两倍error_log logs/error.log crit; #定义全局错误日志文件日志的级别如下:crit为输出日志最少的# debug|info|notice|warn|error|critpid logs/nginx.pid; #定义进程ID的存储文件位置#Specifies the value for maximum file descriptors that can be opened by this process.worker_rlimit_nofile 65535;events {use epoll; #Linux下最常用支持大并发的工作模式worker_connections 65535; #定义每个进程的最大连接数}http {include mime.types; #定义mime类型,类型由mime.type文件定义default_type application/octet-stream;charset utf-8; #设置字符集log_format main '$remote_addr - $remote_user [$time_local] "$request" ''$status $body_bytes_sent "$http_referer" ''"$http_user_agent" "$http_x_forwarded_for"'; #指定Nginx日志输出格式access_log logs/access.log main;#设定请求缓冲server_names_hash_bucket_size 256; #增加,原为128client_header_buffer_size 256k; #增加,原为32klarge_client_header_buffers 4 256k; #增加,原为32k#size limitsclient_max_body_size 50m; #定义客户端请求的最大的单个文件字节数client_header_timeout 3m; #定义客户端请求头读取超时时间client_body_timeout 3m; #定义客户端请求主体读取时间,默认60秒send_timeout 3m; #定义响应客户端的超时时间sendfile on; #开启高效文件传输模式tcp_nopush on; #定义何时将缓存输出到最终用户(客户端)keepalive_timeout 60; #定义客户端连接保持活动的超时时间tcp_nodelay on; #定义操作系统如何处理网络缓存server_tokens on; #不显示nginx版本信息limit_conn_zone $binary_remote_addr zone=perip:10m; #添加limit_zone,限制同一IP并发数#fastcgi_intercept_errors on; #开启错误页面跳转include gzip.conf; #压缩配置文件include proxy.conf; #proxy_cache参数配置文件include vhost/*.conf; #nginx虚拟主机包含文件目录include mysvrhost.conf; #后端WEB服务器列表文件}
4)编辑代理配置文件:
[root@crushlinux conf]# mkdir vhost
[root@crushlinux conf]# vi proxy.conf添加时请删除汉字注释信息
#注:proxy_temp_path和proxy_cache_path指定的路径必须在同一分区proxy_temp_path /tmp/proxy_temp;#设置Web缓存区名称为cache_one,内存缓存空间大小为500MB,1天没有被访问的内容自动清除,硬盘缓存空间大小为30GB。proxy_cache_path /tmp/proxy_cache levels=1:2 keys_zone=cache_one:500m inactive=1d max_size=30g;client_body_buffer_size 512k; #原为512kproxy_connect_timeout 50; #代理连接超时proxy_read_timeout 600; #代理发送超时proxy_send_timeout 600; #代理接收超时proxy_buffer_size 128k; #代理缓冲大小,原为32kproxy_buffers 16 256k; #代理缓冲,原为4 64kproxy_busy_buffers_size 512k; #高负荷下缓冲大小,原为128kproxy_temp_file_write_size 1024m; #proxy缓存临时文件的大小原为128k#proxy_ignore_client_abort on; #不允许代理端主动关闭连接proxy_next_upstream error timeout invalid_header http_500 http_503 http_404 http_502 http_504;
5)编辑主机配置文件:
[root@crushlinux conf]# vi /usr/local/nginx/conf/mysvrhost.conf 添加时请删除汉字注释信息
upstream cn100 {ip_hash; #会话保持server 127.0.0.1:8080 max_fails=1 fail_timeout=60s;server 127.0.0.1:9080 max_fails=1 fail_timeout=60s;}
6)编辑压缩配置文件:
[root@crushlinux conf]# vi /usr/local/nginx/conf/gzip.conf添加时请删除汉字注释信息
#网页GZIP压缩设置#2012.4.2#可通过http://tool.chinaz.com/Gzips/检测压缩情况#启动预压缩功能,对所有类型的文件都有效#gzip_static on; #开启nginx_static后,对于任何文件都会先查找是否有对应的gz文件#找不到预压缩文件,进行动态压缩gzip on;gzip_min_length 1k; #设置最小的压缩值,单位为bytes.超过设置的min_length的值会进行压缩,小于的不压缩.gzip_comp_level 3; #压缩等级设置,1-9,1是最小压缩,速度也是最快的;9刚好相反,最大的压缩,速度是最慢的,消耗的CPU资源也多gzip_buffers 16 64k; #设置系统的缓存大小,以存储GZIP压缩结果的数据流,它可以避免nginx频烦向系统申请压缩空间大小gzip_types text/plain application/x-javascript text/css text/javascript;#关于gzip_types,如果你想让图片也开启gzip压缩,那么用以下这段吧:#gzip_types text/plain application/x-javascript text/css text/javascript application/x-httpd-php p_w_picpath/jpeg p_w_picpath/gif p_w_picpath/png;#gzip公共配置gzip_http_version 1.1; #识别http的协议版本(1.0/1.1)gzip_proxied any; #设置使用代理时是否进行压缩,默认是off的gzip_vary on; #和http头有关系,加个vary头,代理判断是否需要压缩gzip_disable "MSIE [1-6]."; #禁用IE6的gzip压缩
7)编辑配置文件:
[root@crushlinux conf]# vi /usr/local/nginx/conf/vhost/cn100.conf 添加时请删除汉字注释信息
server {listen 80;server_name localhost;#默认启动文件index index.html index.htm;#配置发布目录为/usr/local/tomcat1/webapps/ROOTroot /usr/local/tomcat1/webapps/ROOT;location /{#如果后端的服务器返回502、504、执行超时等错误,自动将请求转发到upstream负载均衡池中的另一台服务器,实现故障转移。proxy_next_upstream http_502 http_504 error timeout invalid_header;proxy_cache cache_one;#对不同的HTTP状态码设置不同的缓存时间proxy_cache_valid 200 304 12h;#以域名、URI、参数组合成Web缓存的Key值,Nginx根据Key值哈希,存储缓存内容到二级缓存目录内proxy_cache_key $host$uri$is_args$args;proxy_set_header Host $host;proxy_set_header X-Real-IP $remote_addr;proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;proxy_pass http://cn100;#对用户传输Set-Cookie的http头,不然无法支持一些包含cookie的应用,比如我的typechoproxy_pass_header Set-Cookie;#过期时间3天expires 3d;}#用于清除缓存,假设一个URL为http://192.168.8.42/test.txt,通过访问http://192.168.8.42/purge/test.txt就可以清除该URL的缓存。location ~ /purge(/.*){#设置只允许指定的IP或IP段才可以清除URL缓存。allow 127.0.0.1;allow 192.168.0.0/16;deny all;proxy_cache_purge cache_one $host$1$is_args$args;}# 查看nginx的并发连接数配置location /NginxStatus{stub_status on;access_log off;auth_basic "NginxStatus";}#定义Nginx输出日志的路径#access_log /data/logs/nginx_wugk/access.log main;#error_log /data/logs/nginx_wugk/error.log crit;#access_log off; #根据自己的需要选择是否启用access日志,注释掉代表启用error_page 404 /404.html;error_page 500 502 503 504 /404.html;location = /404.html {root html;}limit_conn perip 50; #同一ip并发数为50,超过会返回503}
8)为Tengine配置系统的TCP设置
[root@crushlinux conf]# vi /etc/sysctl.confnet.ipv4.ip_forward = 0net.ipv4.conf.default.rp_filter = 1net.ipv4.conf.default.accept_source_route = 0kernel.sysrq = 0kernel.core_uses_pid = 1net.ipv4.tcp_syncookies = 1kernel.msgmnb = 65536kernel.msgmax = 65536kernel.shmmax = 68719476736kernel.shmall = 4294967296net.ipv4.tcp_max_tw_buckets = 6000net.ipv4.tcp_sack = 1net.ipv4.tcp_window_scaling = 1net.ipv4.tcp_rmem = 4096 87380 4194304net.ipv4.tcp_wmem = 4096 16384 4194304net.core.wmem_default = 8388608net.core.rmem_default = 8388608net.core.rmem_max = 16777216net.core.wmem_max = 16777216net.core.netdev_max_backlog = 262144net.core.somaxconn = 262144net.ipv4.tcp_max_orphans = 3276800net.ipv4.tcp_max_syn_backlog = 262144net.ipv4.tcp_timestamps = 0net.ipv4.tcp_synack_retries = 1net.ipv4.tcp_syn_retries = 1net.ipv4.tcp_tw_recycle = 1net.ipv4.tcp_tw_reuse = 1net.ipv4.tcp_mem = 94500000 915000000 927000000net.ipv4.tcp_fin_timeout = 1net.ipv4.tcp_keepalive_time = 30net.ipv4.ip_local_port_range = 1024 65000使配置生效:[root@crushlinux conf]# /sbin/sysctl -p
9)重Tengine
service nginx restart
10) 测试:
[root@crushlinux ~]# elinks --dump http://192.168.200.129